// ==============================================================
//                 ORBITER MODULE: EAGLEHANGAR2
//                  Part of the ORBITER SDK
//          Copyright (C) 2002-2004 Martin Schweiger
//                   All rights reserved
//
// EAGLEHANGAR2.cpp
// Control module for EAGLEHANGAR2 vessel class
//
// Notes:
// This is an example for a "minimal" vessel implementation which
// only overloads the clbkSetClassCaps method to define vessel
// capabilities and otherwise uses the default VESSEL class
// behaviour.
// ==============================================================



//#include "orbitersdk.h"
#include "UMmuSDK.h"

// ==============================================================
// Some vessel parameters
// ==============================================================

// Interface for derived vessel class: QJBStar
// ==========================================================

class ARROWHANGAR2: public VESSEL2 {
public:
    ARROWHANGAR2 (OBJHANDLE hObj, int fmodel);
	void clbkSaveState(FILEHANDLE scn);
       void clbkPostCreation (void);
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkLoadStateEx (FILEHANDLE scn, void *status);
	int clbkConsumeBufferedKey(DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
 	void DefineAnimations(void); 
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);
	void clbkPostStep (double simtt, double simdt, double mjd);
	void clbkDrawHUD (int mode, const HUDPAINTSPEC *hps, HDC hDC);
	void RevertDOOR1();
	void RevertDOOR();

	void RevertDOOR2();
	void RevertDOOR3();
	void RevertDOOR4();
	void RevertDOOR5();
	void RevertDOOR6();
	void RevertDOOR7();
	void RevertDOOR8();







enum DOORStatus { DOOR_UP, DOOR_DOWN, DOOR_RAISING, DOOR_LOWERING } DOOR0_status,DOOR1_status,DOOR2_status,DOOR3_status,DOOR4_status,DOOR5_status,DOOR6_status,DOOR7_status,DOOR8_status;

//void Estado();
// UMMU 2.0 DECLARATION
	UMMUCREWMANAGMENT Crew;
	int SelectedUmmuMember;				// for the SDK demo, select the member to eva
	int iActionAreaDemoStep;			// this is just to show one feature of action area.
	void clbkSetClassCaps_UMMu(void);	// our special SetClassCap function just added for more readability

	// The HUD display method variable, see PDF doc
	char cUmmuHudDisplay[255];			// UMmu hud char variable
	double dHudMessageDelay;			// UMmu hud display delay
	char *SendHudMessage(void);			// UMmu hud display function

	// THIS IS FOR ADDING CREW SEE PDF doc "Allow user to add crew to your ship 
	// without scenery editor"
	char cAddUMmuToVessel[255];
	void AddUMmuToVessel(BOOL bStartAdding=FALSE);
private:
double DOOR0_proc,LIFT_SPEED,DOOR1_proc,DOOR2_proc,DOOR3_proc,DOOR4_proc,DOOR5_proc,DOOR6_proc,DOOR7_proc,DOOR8_proc;
int ARROWHANGARSoundID;
double UpdateOnly2TimePerSecond;

UINT BUG0;
MESHHANDLE TUBE;
UINT anim_DOOR1;
UINT anim_DOOR2;
UINT anim_DOOR3;
UINT anim_DOOR4;
UINT anim_DOOR5;
UINT anim_DOOR6;
UINT anim_DOOR7;
UINT anim_DOOR8;
UINT anim_DOOR9;
UINT anim_DOOR10;
UINT anim_DOOR11;
UINT anim_DOOR12;
UINT anim_DOOR13;
UINT anim_DOOR14;
UINT anim_DOOR15;
UINT anim_DOOR16;
UINT anim_DOOR17;
UINT anim_DOOR18;
UINT anim_DOOR19;
UINT anim_DOOR20;
UINT anim_DOOR21;
UINT anim_DOOR22;
UINT anim_airlock1;
UINT anim_airlock2;

UINT anim_DOOR51;
UINT anim_DOOR52;
UINT anim_DOOR53;
UINT anim_DOOR61;
UINT anim_DOOR62;
UINT anim_DOOR63;
UINT anim_DOOR64;

UINT anim_DOOR71;
UINT anim_DOOR72;
UINT anim_DOOR73;
UINT anim_DOOR81;
UINT anim_DOOR82;
UINT anim_DOOR83;
UINT anim_DOOR74;

};